<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.event.plugin');


class plgFlexicontent_fieldsJfflexiopencalais extends JPlugin
{
	function plgFlexicontent_fieldsJfflexiopencalais( &$subject, $params )
	{
		parent::__construct( $subject, $params );
        JPlugin::loadLanguage('plg_flexicontent_fields_jfflexiopencalais', JPATH_ADMINISTRATOR);
	}

	function onDisplayField(&$field, $item)
	{
		if($field->field_type != 'jfflexiopencalais')
		{
			return;
		}
		else
		{
			$document =& JFactory::getDocument();
			$db 	=& JFactory::getDBO();


		// initialise property
		if (!$field->value) {
			$field->value = array();
			$field->value[0] = '';
		}

			//We get the opencalais keywords allready linked to this article
		$query 	=	'SELECT v.keyword,v.ent_id, rel.*, e.name '
					. 'FROM #__jfopencalais_keywords as v '
					. ' INNER JOIN #__jfopencalais_keys_content_relation as rel on rel.id = v.id '
					. ' INNER JOIN #__jfopencalais_entities AS e ON e.id = v.ent_id '
					. ' WHERE rel.item_id = '.$item->id
					. ' ORDER BY e.name';
//					echo $query;die;
		$db->setQuery($query);
		$rows = $db->loadObjectList();


			//add the drag and drop sorting feature
			$js = "
			window.addEvent('domready', function(){
			
			var i=".sizeof($rows).";
			
				jQuery('#getopencalais').click(function () {
				
				//In first load the loading img
				jQuery('#imgloadingoc').html('<img src=\"components/com_flexicontent/assets/images/ajax-loader.gif\" />');
						
				var str = jQuery('#text').serialize();
			      jQuery.ajax({
			         type: 'POST',
			         url: 'index.php?option=com_jfopencalais&c=flexicontent&format=xml&task=getocdatas',
			         data: 'text=' + str,
			         dataType: 'xml',
			         success:function(xml){
			         				deleteAllField();
			         				if (jQuery(xml).find('error')) {
			         					var errortxt = jQuery(xml).find('error').text();
			         					addErrorValue(errortxt);
			         				}
			         				
							      	jQuery(xml).find('type').each(function(){
				                var typename = jQuery(this).find('typename').text();
				                jQuery(this).find('keyword').each(function(){
				                			
							                var keyword = jQuery(this).text();
				                			addKeyValue(i,typename,keyword);
				                			i++;
				                });
				            });
				            	jQuery('#imgloadingoc').html('');
			          }
			       })
				});
				
				jQuery('#addentkey').click(function () {
				
						addKeyValue(i,jQuery('#txtentity').val(),jQuery('#txtkeyword').val());
						i++;
						jQuery(\"#txtentity\").val('');
						jQuery(\"#txtkeyword\").val('');
				});				
				
				
			jQuery(\"#txtentity\").autocomplete('index.php?option=com_jfopencalais&c=flexicontent&format=raw&task=getentities&".JUtility::getToken()."=1', {
				multiple: false,
				dataType: 'json',
				parse: function(data) {
					return jQuery.map(data, function(row) {
						return {
							data: row,
							value: row.name,
							result: row.name
						}
					});
				},
				formatItem: function(item) {
					return item.name;
				}
			});
				
				
			jQuery(\"#txtkeyword\").autocomplete('index.php?option=com_jfopencalais&c=flexicontent&format=raw&task=getkeywords&".JUtility::getToken()."=1', {
				multiple: false,
				dataType: 'json',
				parse: function(data) {
					return jQuery.map(data, function(row) {
						return {
							data: row,
							value: row.name,
							result: row.name
						}
					});
				},
				formatItem: function(item) {
					return item.name;
				}
			});				
		 });";

			$js .= "
			
						function addErrorValue(el) {
			
						var li 		= document.createElement('li');
						var spanerr	= document.createElement('span');

						spanerr.innerHTML = el;
						jQuery(spanerr).addClass('error');
						
						var liste = document.getElementById('list_oc_key');
						
						liste.appendChild(li);
						li.appendChild(spanerr);

			}
			
			function addKeyValue(i,entity,el) {
			
						var li 		= document.createElement('li');
						var spanent	= document.createElement('span');
						var spankey	= document.createElement('span');
						var spanspace	= document.createElement('span');

						spanent.innerHTML = entity;
						jQuery(spanent).addClass('entity');
						spankey.innerHTML = el;
						jQuery(spankey).addClass('keyword');
						spanspace.innerHTML = ' - ';
						jQuery(spanspace).addClass('space');

      			var inputent = document.createElement('input');
						inputent.type = 'hidden';
						inputent.name = '".$field->name."['+i+'][entity]';
						inputent.value = entity;

      			var inputkey = document.createElement('input');
						inputkey.type = 'hidden';
						inputkey.name = '".$field->name."['+i+'][keyword]';
						inputkey.value = el;

      			var button = document.createElement('input');
						button.type = 'button';
						button.name = 'removebutton';
						jQuery(button).addClass('fcbuttonoc');
						button.setAttribute('onClick','deleteField('+i+')');

						button.value = 'Remove';

						li.id = 'rel'+i;
						
						var liste = document.getElementById('list_oc_key');
						
						liste.appendChild(li);
						li.appendChild(button);
						spanent.appendChild(inputent);
						li.appendChild(spanent);
						li.appendChild(spanspace);
						spankey.appendChild(inputkey);
						li.appendChild(spankey);
			}

			function deleteField(el) {
							jQuery('#rel'+el).remove();
			}

			function deleteAllField() {
					jQuery('#list_oc_key li').remove();
			}";

			$document->addScriptDeclaration($js);
			
			$css = '
			.opencalaiskeylist { 
				list-style:none outside none;
				margin:0;
				padding:0;
			}

			.opencalaiskeylist li{ 
				list-style:none outside none;
				margin-top:2px;
				margin-bottom:2px;
			}
			#imgloadingoc {
			padding-left:5px;
			}
			.fcbuttonoc {
			margin-right:10px;
			cursor: pointer;
			}
			';
			$document->addStyleDeclaration($css);
			
			
			$field->html	 = '<input type="button" class="fcbutton" name="getopencalais" id="getopencalais" value="Get OpenCalais Keywords" /><span id="imgloadingoc"></span>';
			$field->html .= '<ul id="list_oc_key" class="opencalaiskeylist">';

			if ($rows) {
			foreach ($rows as $value) {
								
				$field->html	.= '
				<li id="rel'.$value->id.'">
					<input class="fcbuttonoc" type="button" value="Remove" onclick="deleteField('.$value->id.');" />
					<span class="entity">'.$value->name.' <input type="hidden" value="'.$value->name.'" name="'.$field->name.'['.$value->id.'][entity]" /></span>
					<span class="space"> - </span>
					<span class="keyword">'.$value->keyword.' <input type="hidden" value="'.$value->keyword.'" name="'.$field->name.'['.$value->id.'][keyword]" /></span>
				</li>';
				}

		}}
			$field->html .=	'</ul>';
		
		$field->html .= '<ul id="oc_customvalues" class="opencalaiskeylist">';
				$field->html	.= '
				<li>					
					<span class="entity"><input type="text" id="txtentity" name="txtentity" /></span>
					<span class="space"> - </span>
					<span class="keyword"><input type="text" value="" name="txtkeyword" id="txtkeyword" /></span>
					<input type="button" class="fcbutton" name="addentkey" id="addentkey" value="Add Custom values" />
				</li>';
		$field->html .=	'</ul>';
		

	}

	function onBeforeSaveField( $field, &$post, &$file )
	{
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'jfflexiopencalais') return;
		//Save datas in the jfopencalais component database

		//var_dump($field);die;
		//Delete all keyword/link for this article in first
		$this->delLinkEntityItem($field->item_id);

		$publishedbydefault = $field->parameters->get('publishedbydefault', 0);

		//Next whe save all
		foreach($post as $ocvalue) {
			$entid = $this->checkEntity(array('name' => $ocvalue['entity']));
			$keyid = $this->checkEntityValue(array('ent_id' => $entid , 'valuename' => $ocvalue['keyword'],'publishedbydefault' => $publishedbydefault ));
			$this->savelinkEntityValue(array('val_id' => $keyid , 'item_id' => $field->item_id ));			
		}

//		unset($post);
	}

	function onDisplayFieldValue(&$field, $item, $values=null, $prop='display')
	{
		if($field->field_type != 'jfflexiopencalais')
		{
			return;
		}   
		else
		{	
		$document =& JFactory::getDocument();

		$values = $values ? $values : $field->value ;
		$arrayentkey = array();
		
		foreach ($values as $value) {
			$value = unserialize($value);
			//WE create a table with all the keywords for this article
			$arrayentkey[$value['entity']][]	= $value['keyword'];
		}

		$finalarray = array();
		//Now we checked if the datas can be published and get the display field
		foreach ($arrayentkey as $ent => $arraykeyword) {
			$entitydatas = $this->isEntityPublished($ent);
			
			if ($entitydatas) {
				foreach($arraykeyword as $mykey) {
						//The same for keywords
					$keyworddatas = $this->isKeywordPublished(array('ent_id' => $entitydatas->id,'valuename'=> $mykey));
					if ($keyworddatas) {
						$finalarray[$entitydatas->display_name][] = $keyworddatas;
						}
					unset($keyworddatas);
					}
			}
		unset($entitydatas);
		}
//		var_dump($finalarray);
		$field->display = $finalarray;

		}

	}


	function isKeywordPublished($datas)
	{//var_dump($datas);die;
		$db  		= & JFactory::getDBO();
		$query = 'SELECT * '
				.' FROM #__jfopencalais_keywords'
				.' WHERE keyword = '.$db->Quote($datas['valuename']).' AND ent_id = '.$datas['ent_id'] .' AND published = 1';
		$db->setQuery($query);

		$keydatas = $db->loadObject();
		if ($keydatas) {
			return $keydatas;
		}
		else {
			return false;
		}
	}		

	function isEntityPublished($entity)
	{
		$db  		= & JFactory::getDBO();
		/** check for existing name */
		$query = 'SELECT *'
				.' FROM #__jfopencalais_entities'
				.' WHERE name = '.$db->Quote($entity)
				.' AND item_published = 1';
				;
		$db->setQuery($query);

		$entdatas = $db->loadObject();
		if ($entdatas) {
			return $entdatas;
		}
		else {
			return false;
		}
	}


	function checkEntity($datas)
	{
		$db  		= & JFactory::getDBO();
		/** check for existing name */
		$query = 'SELECT id'
				.' FROM #__jfopencalais_entities'
				.' WHERE name = '.$db->Quote($datas['name'])
				;
		$db->setQuery($query);

		$xid = intval($db->loadResult());
		if ($xid) {
			return $xid;
		}
		else {
			$query = 'INSERT INTO #__jfopencalais_entities (`name`,`display_name`,`published`) VALUES(' . $db->Quote($datas['name']) . ',' . $db->Quote($datas['name']) . ',0)';
			$db->setQuery($query);											
			$db->query();
			return $db->insertid();
		}
	}		
			
	function checkEntityValue($datas)
	{
		$db  		= & JFactory::getDBO();
		/** check for existing name */
		$query = 'SELECT id'
				.' FROM #__jfopencalais_keywords'
				.' WHERE keyword = '.$db->Quote($datas['valuename']).' AND ent_id = '.$datas['ent_id'];
				;
//				echo $query.'<br>';
//				echo $query;die;
		$db->setQuery($query);

		$xid = intval($db->loadResult());
		if ($xid) {
			return $xid;
		}
		else {
			$query = 'INSERT INTO #__jfopencalais_keywords (`ent_id`,`keyword`,`display_keyword`,`published`) VALUES(' . $db->Quote($datas['ent_id']) . ', ' . $db->Quote($datas['valuename']) . ', ' . $db->Quote($datas['valuename']) . ','.$datas['publishedbydefault'].')';
			$db->setQuery($query);											
			$db->query();
			return $db->insertid();
		}
	}		

	function savelinkEntityValue($datas)
	{
//		var_dump($datas);die;
		$db  		= & JFactory::getDBO();
		$query = 'INSERT INTO #__jfopencalais_keys_content_relation (`id`,`item_id`) VALUES (' . $db->Quote($datas['val_id']) . ', ' . $db->Quote($datas['item_id']) . ') ON DUPLICATE KEY UPDATE `id` = ' . $db->Quote($datas['val_id']);
		$db->setQuery($query);
		$db->query();
	}					
	
	function delLinkEntityItem($itemid)
	{
		$db  		= & JFactory::getDBO();
		$query = 'DELETE FROM #__jfopencalais_keys_content_relation WHERE item_id = '.$itemid;
		$db->setQuery($query);										
		$db->query();
	}			



}
?>
